/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 1.0
 *
 * Author: Eric HARDESTY
 * --------------------------------------------------------------------------
 * $Id:PoolItemStats.java
 * --------------------------------------------------------------------------
 * 
 */
package org.objectweb.jonas.resource.pool.api;

/** <p>This class holds information about each pool entry.
 *
 *  @author      Eric Hardesty
**/
public class PoolItemStats {

    long maxAgeTimeout = 0L;
    long startTime = 0L;
    long totalConnectionTime = 0L;
    
    int uses = 0;
    
    public void PoolItemStats() {
    }
    
    public long getMaxAgeTimeout() {
        return maxAgeTimeout;
    }

    public void setMaxAgeTimeout(long pTime) {
        maxAgeTimeout = pTime;
    }

    public long getStartTime() {
        return startTime;
    }

    public void setStartTime(long pTime) {
        startTime = pTime;
    }

    public long getTotalConnectionTime() {
        return totalConnectionTime;
    }

    public void setTotalConnectionTime(long pTime) {
        totalConnectionTime += pTime;
    }

    public int getUses() {
        return uses;
    }

    public void incrementUses() {
        uses++;
    }

}