/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Florent BENOIT
 * --------------------------------------------------------------------------
 * $Id: CatalinaJWebContainerServiceImplMBean.java,v 1.2 2003/09/08 16:11:20 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.web.catalina41;

import org.objectweb.jonas.web.AbsJWebContainerServiceImplMBean;

/**
 * This interface provides a description for the specific web container management of Catalina
 * @author Florent Benoit
 */
public interface CatalinaJWebContainerServiceImplMBean extends AbsJWebContainerServiceImplMBean {


   /**
     * Create a new JOnAS StandardContext.
     *
     * @param parent MBean Name of the associated parent component
     * @param path The context path for this Context
     * @param docBase Document base directory (or WAR) for this Context
     * @return The MBean name created
     * @exception Exception if an MBean cannot be created or registered
     */
    String createJOnASStandardContext(String parent, String path, String docBase) throws Exception;



}


