/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Michel-Ange ANTON
 * --------------------------------------------------------------------------
 * $Id: ApplyTopAction.java,v 1.4 2003/10/21 15:08:11 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.objectweb.jonas.jmx.JonasManagementRepr;

public class ApplyTopAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    /**
     * Process the specified HTTP request, and create the corresponding HTTP
     * response (or forward to another web component that will create it).
     * Return an <code>ActionForward</code> instance describing where and how
     * control should be forwarded, or <code>null</code> if the response has
     * already been completed.
     *
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward executeAction(ActionMapping mapping, ActionForm form, HttpServletRequest request
        , HttpServletResponse response)
        throws IOException, ServletException {
        // What locale does the user want to switch to?
        String sRequested = ((TopForm) form).getServerSelect();

        // Switch to the specified locale, if it exists
        if (sRequested != null) {
            String sCurrentRMIConnectorName = null;
            try {
                // Save current RmiConnector
                sCurrentRMIConnectorName = JonasManagementRepr.getCurrentRMIConnectorName();
                // Set the new RmiConnector
                JonasManagementRepr.setCurrentRMIConnectorName(sRequested);
            }
            catch (Exception e) {
                ActionErrors errors = new ActionErrors();
                // Delete RMIconnector_ of string
                String sServerName = sRequested.substring(13);
                errors.add("serverSelect", new ActionError("error.server.jonas.serverName.bad"
                    , sServerName));
                try {
                    // Restore current RmiConnector
                    JonasManagementRepr.setCurrentRMIConnectorName(sCurrentRMIConnectorName);
                }
                catch (Exception eBis) {
                    // none
                }
                saveErrors(request, errors);
            }
        }
        // Forward control back to the ActionEditTop
        return (mapping.findForward("ActionEditTop"));
    }
}
