/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ItemByNameComparator.java,v 1.1 2003/09/04 07:19:32 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.common;

import java.util.Comparator;


/**
 * @author Michel-Ange ANTON
 */
public class ItemByNameComparator implements Comparator {

// --------------------------------------------------------- Public Methods

    public int compare(Object p_O1, Object p_O2) {
        NameItem o1 = (NameItem) p_O1;
        NameItem o2 = (NameItem) p_O2;
        return o1.getName().compareToIgnoreCase(o2.getName());
    }

    public boolean equals(Object p_Obj) {
        if (p_Obj instanceof NameItem) {
            return (compare(this, p_Obj) == 0);
        }
        return false;
    }
}