/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EditEarAction.java,v 1.4 2003/08/07 12:26:02 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.container;

import java.io.IOException;
import java.net.URL;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminJmx;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author Michel-Ange ANTON
 */

public class EditEarAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {

        // Selected ear
        String sPath = p_Request.getParameter("path");

        // Form used
        EarForm oForm = null;
        // Build a new form
        if (sPath != null) {
            oForm = new EarForm();
            oForm.reset(p_Mapping, p_Request);
            m_Session.setAttribute("earForm", oForm);
            oForm.setPath(sPath);
            oForm.setFilename(JonasAdminJmx.extractFilename(sPath));
        }
        else {
            // Used last form in session
            oForm = (EarForm) m_Session.getAttribute("earForm");
        }

        // Force the node selected in tree
        m_WhereAreYou.selectNameNode(getTreeBranchName(1) + ";services;ear;" + oForm.getFilename(), true);

        // Populate
        try {
            if (sPath != null) {
                // Object name used
                ObjectName oObjectName = JonasObjectName.ear(oForm.getPath());
                oForm.setEarPath((URL) JonasManagementRepr.getAttribute(oObjectName, "EarUrl"));
                oForm.setXmlDeploymentDescriptor(getStringAttribute(oObjectName
                    , "DeploymentDescriptor"));
                oForm.setListWars((URL[]) JonasManagementRepr.getAttribute(oObjectName, "Wars"));
                oForm.setListJars((URL[]) JonasManagementRepr.getAttribute(oObjectName, "EjbJars"));
                oForm.setListRars((URL[]) JonasManagementRepr.getAttribute(oObjectName, "Rars"));
            }
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.
        return (p_Mapping.findForward("Ear"));
    }
}
