/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EditResourceAdapterAction.java,v 1.1 2003/09/15 16:02:14 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.container;

import java.io.IOException;
import java.net.URL;
import java.util.Properties;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminJmx;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author Michel-Ange ANTON
 */

public class EditResourceAdapterAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {

        // Selected resource adapter
        String sName = p_Request.getParameter("name");
        if (sName == null) {
            sName = (String)p_Request.getAttribute("name");
        }

        // Form used
        ResourceAdapterForm oForm = null;
        // Build a new form
        if (sName != null) {
            oForm = new ResourceAdapterForm();
            oForm.reset(p_Mapping, p_Request);
            m_Session.setAttribute("resourceAdapterForm", oForm);
            oForm.setName(sName);
        }
        else {
            // Used last form in session
            oForm = (ResourceAdapterForm) m_Session.getAttribute("resourceAdapterForm");
        }

        // Force the node selected in tree
        m_WhereAreYou.selectNameNode(getTreeBranchName(1) + ";services;resourceAdapter;"
            + oForm.getName(), true);

        // Populate
        try {
            if (sName != null) {
                // Object name used
                ObjectName oObjectName = JonasObjectName.resourceAdapter(oForm.getName());
                oForm.setPath(getStringAttribute(oObjectName, "Filename"));
                oForm.setFile(JonasAdminJmx.extractFilename(oForm.getPath()));
                oForm.setInEar(getBooleanAttribute(oObjectName, "InEarCase"));
                oForm.setEarPath((URL) JonasManagementRepr.getAttribute(oObjectName, "EarURL"));
                oForm.setListProperties((Properties) JonasManagementRepr.getAttribute(oObjectName, "Properties"));
            }
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.
        return (p_Mapping.findForward("Resource Adapter"));
    }
}
