/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EditWebAppCatalinaAction.java,v 1.1 2003/08/28 16:24:03 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.container;

import java.io.IOException;
import java.net.URL;
import java.util.Iterator;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasAdminJmx;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
import org.objectweb.jonas.webapp.jonasadmin.CatalinaObjectName;

/**
 * @author Michel-Ange ANTON
 */

public class EditWebAppCatalinaAction extends BaseWebAppAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {

        // Initialize form
        boolean bPopulate = initialize(p_Mapping, p_Request);

        try {
            // Populate
            if (bPopulate == true) {
                // Force the node selected in tree
                m_WhereAreYou.selectNameNode(getTreeBranchName(1) + ";services;web;"
                    + m_WebAppForm.getPathContext(), true);
                // Populate WebApp
                populateWebAppCatalina(m_WebAppForm.getPathContext()
                    , (WebAppCatalinaForm) m_WebAppForm);
                // Detect War
                ObjectName on = findJonasMbeanWar(m_WebAppForm.getPathContext());
                if (on != null) {
                    // Populate War
                    m_WarForm = createWarForm(p_Mapping, p_Request);
                    populateWar(on, m_WarForm);
                }
            }
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.
        return (p_Mapping.findForward("WebApp Catalina"));
    }

// --------------------------------------------------------- Protected Methods

}
