/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: WebAppItem.java,v 1.2 2003/08/28 16:24:03 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.service.container;

import javax.management.ObjectName;
import org.objectweb.jonas.webapp.jonasadmin.Jlists;

/**
 * @author Michel-Ange ANTON
 */
public class WebAppItem extends ContainerItem {

// --------------------------------------------------------- Properties Variables

    private String pathContext = null;
    private boolean deployed = false;
    private String objectName = null;

// --------------------------------------------------------- Constructors

    public WebAppItem() {
    }

    public WebAppItem(String p_PathContext) {
        setPathContext(p_PathContext);
    }

    public WebAppItem(String p_PathContext, String p_ObjectName) {
        setPathContext(p_PathContext);
        setObjectName(p_ObjectName);
    }

// --------------------------------------------------------- Properties Methods

    public String getPathContext() {
        return pathContext;
    }

    public String getPathContextLabel() {
        return Jlists.getDefaultLabelPathContext(pathContext);
    }

    public void setPathContext(String pathContext) {
        this.pathContext = pathContext;
    }

    public boolean isDeployed() {
        return deployed;
    }

    /**
     * Extend parent method to set the property <code>deployed</code>.
     *
     * @param p_Path The complete path (docBase) of the web application
     */
    public void setPath(String p_Path) {
        super.setPath(p_Path);
        if (getPath() != null) {
            deployed = true;
        }
    }

    public String getObjectName() {
        return objectName;
    }

    public void setObjectName(String objectName) {
        this.objectName = objectName;
    }
}