/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial Developer : Delplanque Xavier & Sauthier Guillaume
 * --------------------------------------------------------------------------
 * $Id: JServiceFactory.java,v 1.1 2003/09/16 14:15:55 sauthieg Exp $
 * --------------------------------------------------------------------------
*/

package org.objectweb.jonas.ws;

import org.objectweb.jonas.ws.WSServiceException;

import org.objectweb.jonas_ws.deployment.api.ServiceRef;

import javax.xml.rpc.Service;


/**
 * JServiceFactory is used to create the JaxRpc Service. 
 * It must be implemented for all different WebServices Engine.
 *
 * @author Guillaume Sauthier
 */
public interface JServiceFactory {
    /**
     * Create the JaxRpx Service Object associated with the service-ref
     *
     * @param sr The service-ref description
     * @param cl The classloader used to load Service class
     *
     * @return The Service object
     *
     * @throws WSServiceException When instantiation fails
     */
    public Service getService(
        ServiceRef  sr,
        ClassLoader cl) throws WSServiceException;
}
