/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial Developer : Delplanque Xavier & Sauthier Guillaume
 * --------------------------------------------------------------------------
 * $Id: AxisWSServiceImpl.java,v 1.2 2003/10/03 09:55:41 sauthieg Exp $
 * --------------------------------------------------------------------------
*/

package org.objectweb.jonas.ws.axis;

import javax.naming.Context;
import javax.xml.rpc.Service;
import org.apache.axis.AxisProperties;
import org.objectweb.jonas.service.ServiceException;
import org.objectweb.jonas.ws.AbsWebServicesServiceImpl;
import org.objectweb.jonas.ws.WSServiceException;

/**
 * Implements commons methods declared within the abstract class. It's used
 * AXIS classes for specific deployment aspects.
 *
 * @author Guillaume Sauthier & Xavier Delplanque
 */
public class AxisWSServiceImpl extends AbsWebServicesServiceImpl {

    /** Default Axis Dispatching servlet-name */
    private static final String AXIS_SERVLET_NAME = "AxisServlet";

    /**
     * Axis specific configuration. Used when port-component-link is found and
     * a Service class has a dummy URL location.
     *
     * @param service The JaxRpc Service to be configured.
     * @param ctx Configuration Context.
     *
     * @return The configured Service.
     *
     * @throws WSServiceException When configuration fails.
     */
    public Service configureJaxRpcService(
        Service service,
        Context ctx) throws WSServiceException {
        return service;
    }

    /**
     * Return the Engine specific Default servlet name
     *
     * @return the Engine specific Default servlet name
     */
    public String getDefaultServletName() {
        return AXIS_SERVLET_NAME;
    }

    /**
     * Init the AxisWSService.
     *
     * @param ctx Context for configuration.
     *
     * @throws ServiceException when init fails.
     */
    public void doInit(Context ctx) throws ServiceException {
        super.doInit(ctx);
    }
}
