/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Xavier Delplanque & Guillaume Sauthier
 * --------------------------------------------------------------------------
 * $Id: XmlException.java,v 1.1 2003/09/18 14:07:25 delplanx Exp $
 * --------------------------------------------------------------------------
*/

package org.objectweb.jonas_ws.wsgen.xml;

import org.objectweb.jonas_ws.wsgen.WsGenException;

public class XmlException extends WsGenException {
        /**
     * Constructs a XmlException with no specified detail message.
     */
    public XmlException() {
        super();
    }

    /**
     * Constructs an XmlException with the specified detail message.
     */
    public XmlException(String msg) {
        super(msg);
    }

    public XmlException(Exception inner) {
	super();
	this.inner = inner;
    }

    public XmlException(String msg, Exception inner) {
        super(msg);
        this.inner = inner;

    }

}
