@Echo Off
Rem  ---------------------------------------------------------------------------
Rem  JOnAS: Java(TM) Open Application Server
Rem  Copyright (C) 1999 Bull S.A.
Rem  Contact: jonas-team@objectweb.org
Rem  
Rem  This library is free software; you can redistribute it and/or
Rem  modify it under the terms of the GNU Lesser General Public
Rem  License as published by the Free Software Foundation; either
Rem  version 2.1 of the License, or any later version.
Rem  
Rem  This library is distributed in the hope that it will be useful,
Rem  but WITHOUT ANY WARRANTY; without even the implied warranty of
Rem  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Rem  Lesser General Public License for more details.
Rem  
Rem  You should have received a copy of the GNU Lesser General Public
Rem  License along with this library; if not, write to the Free Software
Rem  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
Rem  USA
Rem 
Rem  Initial developer(s): Philippe Durieux
Rem  Contributor(s):
Rem  ---------------------------------------------------------------------------
Rem  $Id: junit.bat,v 1.3 2003/06/17 14:04:40 danesa Exp $
Rem  ---------------------------------------------------------------------------

Rem Usage:	junit [ test-type [ dir-name [ suite-name [ test-name ] ] ] ]
Rem
Rem This script allows to run the jonas-test all the tests or a sub-set of the tests:
Rem - the tests of the given directory
Rem - the tests of the given suite of the given directory
Rem - only the given test of the given suite of the given directory
Rem for each type test (conformance, stress or ws)
Rem
setlocal

Rem Update the following lines depending on your own environment
Set CLASSPATH=%CLASSPATH%;c:\products\jakarta-ant-1.5\lib\junit.jar


set TYPE=conf
set PACK=org.objectweb.jonas.jtests.clients
set DIR=
set SUITE=
set TEST=
set PROJ_BASE=
set TEST_CLASSES=%PROJ_BASE%\objectweb\jonas_tests\conformance\classes

if [%HTTP_PORT%]==[] set HTTP_PORT=8080

if [%1]==[] goto endargs
set TYPE=%1
shift
if [%1]==[] goto endargs
set DIR=%1
shift
if [%1]==[] goto endargs
set SUITE=%1
shift
if [%1%]==[] goto varinit
set TEST=-n %1
goto varinit


:endargs
echo %TYPE%
echo %DIR%
echo %SUITE%
if [%DIR%]==[] set DIR=suite
if [%SUITE%]==[] set SUITE=C_%DIR%

:varinit
if [%TYPE%]==[stress] goto varstress
if [%TYPE%]==[ws] goto varws
:varconf
set PACK=org.objectweb.jonas.jtests.clients
set TEST_CLASSES=%PROJ_BASE%\objectweb\jonas_tests\conformance\classes
goto calllabel
:varstress
set PACK=org.objectweb.jonas.stests
set TEST_CLASSES=%PROJ_BASE%\objectweb\jonas_tests\stress\classes
goto calllabel
:varws
set PACK=org.objectweb.ws.clients
set TEST_CLASSES=%PROJ_BASE%\objectweb\jonas_tests\ws\classes
set JAVA_OPTS=%JAVA_OPTS% -Dhttp.port=%HTTP_PORT% -Daddressbook.dir=%PROJ_BASE%\jonas_tests\ws\src\org\objectweb\ws\ab_web -Dordering.dir=%PROJ_BASE%\jonas_tests\ws\src\org\objectweb\ws\ordering_app
goto calllabel

:calllabel

Set CLASSPATH=%CLASSPATH%;%TEST_CLASSES%

echo on

call jclient %PACK%.%DIR%.%SUITE% %TEST%
