/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: A_ABClassClient.java,v 1.2 2003/06/10 15:49:37 sauthieg Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.ws.clients.jaxrpc;

import org.objectweb.ws.ab_client.gen.Address;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;

public abstract class A_ABClassClient extends A_AddressBookTest {

    public A_ABClassClient(String name) {
        super(name);
    }
    
    protected void checkGetAddressReturn(Address a) throws Exception {
        Address aExp = new Address();

        aExp.setName("Xavier Delplanque");
        aExp.setPhone("045000000");
        aExp.setZip(38000);
        aExp.setCity("Grenoble");
        aExp.setCountry("FRANCE");

        assertEquals("[Class] getAddress return is equal", aExp, a);
        
    }

    protected void checkGetAllAddressesReturn(Address[] adds) throws Exception {

        Address aExp1 = new Address();
        aExp1.setName("Xavier Delplanque");
        aExp1.setPhone("045000000");
        aExp1.setZip(38000);
        aExp1.setCity("Grenoble");
        aExp1.setCountry("FRANCE");

        Address aExp2 = new Address();
        aExp2.setName("Simon Andriot");
        aExp2.setPhone("045000001");
        aExp2.setZip(38000);
        aExp2.setCity("Saint Martin d'Heres");
        aExp2.setCountry("FRANCE");

        List exp = new ArrayList();
        exp.add(aExp1);
        exp.add(aExp2);

        List ret = Arrays.asList(adds);

        assertTrue("[Class] Addresses returns same elements (no order)", ret.containsAll(exp) );
        
    }
}
