/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: A_AddressBookTest.java,v 1.2 2003/06/06 12:32:18 joaninh Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.ws.clients.jaxrpc;

import org.objectweb.ws.util.JTestCase;
import org.objectweb.ws.ab_client_ejb.gen.Address;

import org.apache.axis.client.AdminClient;

public abstract class A_AddressBookTest extends JTestCase {

    private boolean isWebappLoaded = false;

    public A_AddressBookTest(String name) {
        super(name);
    }
    
    /**
     * init environment:
     * - load WS endpoint
     */
    protected void setUp() {
        super.setUp();
        if (!isWebappLoaded) {
            useWebapp("addressbook");
            AdminClient ac = new AdminClient();
            
            String httpPort = System.getProperty("http.port");
            String deploy = System.getProperty("addressbook.dir");
            
            try {
                String[] cmd = new String[2];
                cmd[0] = "-lhttp://localhost:"+httpPort+"/addressbook/servlet/AxisServlet";
                cmd[1] = deploy+"/etc/wsdd/deploy.wsdd";
                
                //  System.out.println("url = " + cmd[0]);
                
                ac.process(cmd);
            }
            catch(Exception e) {
                fail("Cannot Deploy Web Service on Axis ("+httpPort+"): " + e);
                e.printStackTrace(System.out);
            }
            isWebappLoaded = true;
        }
        
    }

    /**
     * reset environment :
     * - unload WS endpoint
     */
    protected void tearDown() throws Exception {
        
        /*
        if (isWebappLoaded) {
            AdminClient ac = new AdminClient();
            
            String httpPort = System.getProperty("http.port");
            String deploy = System.getProperty("addressbook.dir");

            try {
                String[] cmd = new String[2];
                cmd[0] = "-lhttp://localhost:"+httpPort+"/addressbook/servlet/AxisServlet";
                cmd[1] = deploy+"/etc/wsdd/undeploy.wsdd";
                
                // System.out.println("url = " + cmd[0]);
                
                ac.process(cmd);
            }
            catch(Exception e) {
                fail("Cannot Undeploy Web Service on Axis ("+httpPort+"): " + e);
                e.printStackTrace(System.err);
            }
            unloadWebapp("addressbook");
            isWebappLoaded = false;
        }
        */

        super.tearDown();
    }

    protected void checkCountAddressesReturn(int ac) throws Exception {
        int exp = 2;
        assertEquals("number of addresses in book", exp, ac);
    }
    protected void checkGetOwnerReturn(String o) throws Exception {
        String exp = "Guillaume Sauthier";
        assertEquals("getOwner return", exp, o);
    }
    protected void checkAddEntryReturn(String n, String r) throws Exception {
        String exp = "Success : "+ n + " added!";
        assertEquals("addEntry return", exp, r);
    }

}
