/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: A_OrderingEjbTest.java,v 1.1 2003/05/27 12:16:50 sauthieg Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.ws.clients.ssb;
import org.objectweb.ws.ordering_client_ejb.gen.Order;

public abstract class A_OrderingEjbTest extends A_OrderingTest {

    public A_OrderingEjbTest(String name) {
        super(name);
    }
    
    protected void checkGetCustomerOrderReturn(Order orderRes) throws Exception {
        Order order = new Order();
        order.setCustomerName("Xavier Delplanque");
        order.setShippingAddress("12 Liberty Street, Echirolles, France");
        
        String [] items = new String[] {"computer", "television" };
        int [] quantities = new int [] { 2, 12 };
        
        order.setItemCodes(items);
        order.setQuantities(quantities);
        assertEquals("[Ejb] getCustomerOrder return is equal", order,orderRes);
    }

}
