/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: A_OrderingTest.java,v 1.3 2003/06/12 13:31:49 sauthieg Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.ws.clients.ssb;

import org.objectweb.ws.util.JTestCase;

import org.apache.axis.client.AdminClient;

public abstract class A_OrderingTest extends JTestCase {
    
    private boolean isAppLoaded = false;

    public A_OrderingTest(String name) {
        super(name);
    }
    
    /**
     * init environment:
     * - load WS endpoint
     */
    protected void setUp() {
        super.setUp();
        if (!isAppLoaded){
            
            useApplication("ordering");
            AdminClient ac = new AdminClient();
            
            String httpPort = System.getProperty("http.port");
            String deploy = System.getProperty("ordering.dir");
            
            try {
                String[] cmd = new String[2];
                cmd[0] = "-lhttp://localhost:"+httpPort+"/order/servlet/AxisServlet";
                cmd[1] = deploy+"/etc/wsdd/deploy.wsdd";
                
                ac.process(cmd);
            }
            catch(Exception e) {
                System.out.println("Cannot Deploy Ordering Web Service on Axis : " + e);
                e.printStackTrace(System.out);
            }
            isAppLoaded = true;
        }
    }

    /**
     * reset environment :
     * - unload WS endpoint
     */
    protected void tearDown() throws Exception {
        /*
        if (isAppLoaded) {
            AdminClient ac = new AdminClient();
            
            String httpPort = System.getProperty("http.port");
            String deploy = System.getProperty("ordering.dir");
            
            try {
                String[] cmd = new String[2];
                cmd[0] = "-lhttp://localhost:"+httpPort+"/order/servlet/AxisServlet";
                cmd[1] = deploy+"/etc/wsdd/undeploy.wsdd";
                
                ac.process(cmd);
            }
            catch(Exception e) {
                System.out.println("Cannot Undeploy Web Service on Axis : " + e);
                e.printStackTrace(System.out);
            }
            unloadApplication("ordering");
            isAppLoaded = false;
        }
        */
        super.tearDown();

    }
    protected void checkProcessOrderReturn(String res) throws Exception {
        String sep = System.getProperty("line.separator");

        String response = "Hi, Glen Daniels!" + sep;
        response += sep + "You seem to have ordered the following:" + sep;
        response += sep + "1 of item : mp3jukebox";
        response += sep + "4 of item : 1600mahBattery";        
        response += sep + sep +
            "If this had been a real order processing system, "+
            "we'd probably have charged you about now.";
        assertEquals("getProcessOrder return is equal", response, res);
    }
}
