// OrderClientClient.java
// mini Client for accessing bean OrderClient

package org.objectweb.ws.ordering_client;

import java.rmi.RemoteException;
import java.util.Collection; 
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import org.objectweb.ws.ordering_client.gen.Order;
import org.objectweb.ws.ordering_client.gen.OrderServiceLocal;
import org.objectweb.ws.ordering_client.gen.OrderServiceLocalService;
import org.objectweb.ws.ordering_client.gen.OrderServiceLocalServiceLocator;
/**
 *
 */
public class OrderClient{

    private OrderServiceLocal binding = null;

    public OrderClient (){
        try {
            binding = new OrderServiceLocalServiceLocator().getOrderService();
        } catch (javax.xml.rpc.ServiceException jre) {
            //throw new junit.framework.AssertionFailedError("JAX-RPC ServiceException caught: " + jre );
        }        
    }

    public static void main(String[] arg) {
        
        // get the serviceLocator
        OrderClient client = new OrderClient();
        
        try {
            // Test the process of an Order
            System.out.println("______ process order test ______");        
            Order order = new Order();
            order.setCustomerName("Glen Daniels");
            order.setShippingAddress("275 Grove Street, Newton, MA");
            String [] items = new String[] { "mp3jukebox", "1600mahBattery" };
            int [] quantities = new int [] { 1, 4 };
            order.setItemCodes(items);
            order.setQuantities(quantities);
            
            System.out.println(client.processOrder(order));
            
            // Test to get the last customer order
            System.out.println("______ get customer order test ______");
            Order orderR = client.getCustomerOrder("Xavier Delplanque");
            
            String sep = System.getProperty("line.separator");
            String response = "Hi, " + orderR.getCustomerName() + "!" + sep;
            response += sep + "You're last order is the following:" + sep;
            
            String [] orderItems = orderR.getItemCodes();
            int [] orderQuantities = orderR.getQuantities();
            
            for (int i = 0; i < orderItems.length; i++) {
                response += sep + orderQuantities[i] + " of item : " + orderItems[i];
            }
            
            System.out.println(response);
            
            // ...
            
        } catch(Exception e) {
            e.printStackTrace();
            System.exit(2);
        }
    }

    public String processOrder (Order o) throws java.rmi.RemoteException{
        // delegate to the web service client
        return binding.processOrder(o);
    }
    public Order getCustomerOrder (String c) throws java.rmi.RemoteException{
        return binding.getCustomerOrder(c);
    }
}
