// OrderDiiClientClient.java
// mini Client for accessing bean OrderDiiClient

package org.objectweb.ws.ordering_client_ejb.beans.order_dii_c;

import java.rmi.RemoteException;
import java.util.Collection;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import org.objectweb.ws.ordering_client_ejb.gen.Order;
/**
 *
 */
public class OrderDiiClientClient {

    static Context ctx = null; 
    static OrderDiiClientHome home = null;

    static OrderDiiClient bean = null;

    public static void main(String[] arg) {

	// Get InitialContext
	try {
	    ctx = new InitialContext();
	} catch (NamingException e) {
	    e.printStackTrace();
	    System.exit(2);
	}

	// Lookup bean home 
	String bName = "OrderDiiClientHome";
	try {
	    home = (OrderDiiClientHome) PortableRemoteObject.narrow(ctx.lookup(bName), OrderDiiClientHome.class);
	    bean = home.create();
        java.net.URL endpointURL = null;
        try {
            endpointURL = new java.net.URL("http://localhost:"+arg[0]+"/order/services/OrderService");
        } catch(java.net.MalformedURLException e) {
            e.printStackTrace();
            System.exit(3);
        }
        bean.setEndpointUrl(endpointURL);
        // Test the process of an Order
        System.out.println("_________ process order test _________");        
        Order order = new Order();
        order.setCustomerName("Glen Daniels");
        order.setShippingAddress("275 Grove Street, Newton, MA");
        String [] items = new String[] { "mp3jukebox", "1600mahBattery" };
        int [] quantities = new int [] { 1, 4 };
        order.setItemCodes(items);
        order.setQuantities(quantities);
        
        System.out.println(processOrder(order));

        // Test to get the last customer order
        System.out.println("________ get customer order test _________");
        Order orderR = getCustomerOrder("Xavier Delplanque");
        
        String sep = System.getProperty("line.separator");
        String response = "Hi, " + orderR.getCustomerName() + "!" + sep;
        response += sep + "You're last order is the following:" + sep;
        
        String [] orderItems = orderR.getItemCodes();
        int [] orderQuantities = orderR.getQuantities();
        
        for (int i = 0; i < orderItems.length; i++) {
            response += sep + orderQuantities[i] + " of item : " + orderItems[i];
        }
        
        System.out.println(response);

        // ...
	} catch(Exception e) {
	    e.printStackTrace();
	    System.exit(2);
	}

	// ...
    }

    public static String processOrder (Order o) throws java.rmi.RemoteException{
        // delegate to the web service client
        return bean.processOrder(o);
    }
    public static Order getCustomerOrder (String c) throws java.rmi.RemoteException{
        return bean.getCustomerOrder(c);
    }
}
