/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Xavier Delplanque
 * Contributor(s): _______________________
 *
 * --------------------------------------------------------------------------
 * $Id: OrderDiiClientSLR.java,v 1.1 2003/05/27 12:16:51 sauthieg Exp $
 * --------------------------------------------------------------------------
 *
 * inspirated by AXIS samples : example5
 *
 */
// OrderDiiClientSLR.java
// Stateless Session bean

package org.objectweb.ws.ordering_client_ejb.beans.order_dii_c;

import org.objectweb.ws.ordering_client_ejb.gen.Order;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.AxisFault;
import org.apache.axis.encoding.ser.BeanSerializerFactory;
import org.apache.axis.encoding.ser.BeanDeserializerFactory;

import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.RemoveException;
import javax.ejb.EJBObject;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import org.objectweb.jonas.common.Log;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.api.BasicLevel;

import javax.xml.namespace.QName;
import javax.xml.rpc.ParameterMode;
/**
 *
 */
public class OrderDiiClientSLR implements SessionBean {

    static private Logger logger = null;
    SessionContext ejbContext;

    // ------------------------------------------------------------------
    // SessionBean implementation
    // ------------------------------------------------------------------


    public void setSessionContext(SessionContext ctx) {
        if (logger == null) {
            logger = Log.getLogger("org.objectweb.jonas_tests");
        }
        logger.log(BasicLevel.DEBUG, "");
        ejbContext = ctx;
    }
        

    public void ejbRemove() {
        logger.log(BasicLevel.DEBUG, "");
    }
        

    public void ejbCreate() throws CreateException {
        logger.log(BasicLevel.DEBUG, "");
    }

    public void ejbPassivate() {
        logger.log(BasicLevel.DEBUG, "");
    }

    public void ejbActivate() {
        logger.log(BasicLevel.DEBUG, "");
    }
    
    // ------------------------------------------------------------------
    // OrderDiiClient implementation
    // ------------------------------------------------------------------

    private java.net.URL endpointURL = null;

    public void setEndpointUrl(java.net.URL url)throws RemoteException{
        endpointURL = url;
    }

    public String processOrder(Order order) throws RemoteException
    {
        Service  service = new Service();
        Call     call    = null;
        QName    qn      = new QName( "http://order.beans.ordering_app.ws.objectweb.org", "Order" );
        String result;

        try{
            call = (Call) service.createCall();
            call.registerTypeMapping(Order.class, qn,
                                 new BeanSerializerFactory(Order.class, qn),
                                 new BeanDeserializerFactory(Order.class, qn)); 
        }catch(javax.xml.rpc.ServiceException e ){

        }
        try { 
            call.setTargetEndpointAddress( endpointURL );
            call.setOperationName( new QName("OrderService", "processOrder") );

            result = (String) call.invoke( new Object[] { order } );
        } catch (AxisFault fault) {
            result = "Error : " + fault.toString();
        }
        return result;
    }

    public Order getCustomerOrder(String customer) throws RemoteException
    {
        Service  service = new Service();
        Call     call    = null;
        QName    qn      = new QName( "http://order.beans.ordering_app.ws.objectweb.org", "Order" );

        Order result = null;

        try{
            call = (Call) service.createCall();
            call.registerTypeMapping(Order.class, qn,
                                 new BeanSerializerFactory(Order.class, qn),
                                 new BeanDeserializerFactory(Order.class, qn)); 
        }catch(javax.xml.rpc.ServiceException e ){
            
        }
        try {
            call.setTargetEndpointAddress( endpointURL );
            call.setOperationName( new QName("OrderService", "getCustomerOrder") );

            result = (Order) call.invoke( new Object[] { customer } );
        } catch (AxisFault fault) {
            //result = "Error : " + fault.toString();
        }
        return result;
    }
}

