// MdbClientClient.java
// mini Client for accessing topic associated to bean MdbClientMD

package org.objectweb.ws.beans.mdbclient;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.*;
import javax.jms.*;

/**
 *
 */
public class MdbClientClient { 

    static Context ictx = null;
    static TopicConnectionFactory tcf = null;
    static TopicPublisher tp = null;
    static Topic topic = null;
    // JNDI name of the Topic
    static String topicName = "MdbClientTopic";
    // JNDI name of the connection factory
    static String conFactName = "JTCF";

    public static void main(String[] arg) {
	// Get InitialContext
	try {
	    ictx = new InitialContext();
	    // lookup the TopicConnectionFactory through its JNDI name
	    tcf = (TopicConnectionFactory) ictx.lookup(conFactName );
	    System.out.println("JMS client: tcf = " + tcf.toString());
	    // lookup the Topic through its JNDI name
	    topic = (Topic) ictx.lookup(topicName);
	} catch (NamingException e) {
	    e.printStackTrace();
	    System.exit(2);
	}
	TopicConnection tc = null;
	TopicSession session = null;
	try {
	    tc = tcf.createTopicConnection();	
	    System.out.println("JMS client: tc = " + tc.toString());
	    session = tc.createTopicSession(false, Session.AUTO_ACKNOWLEDGE);	
	    tp = session.createPublisher(topic);
	 }catch (Exception e) {
	    e.printStackTrace();
	    System.exit(2);
	}
	// publish A message to the topic
	try {
	    ObjectMessage message;
	    message = session.createObjectMessage();
	    message.setObject("Message1");
	    tp.publish(message);
	    session.close();
	    tc.close();
	} catch (Exception e) {
	    e.printStackTrace();
	    System.exit(2);
	}
    }
}
