// @(#) 1.5 jsr109ri/samples/java/com/ibm/webservices/samples/complex1/Complex1WsClientServlet.java, jsr109ri, jsr109ri, a0241.01 10/9/02 17:56:32 [10/13/02 09:45:39]
/*************************************************************************
   Licensed Materials - Property of IBM
   WSEE1.0 (C) Copyright International Business Machines Corp. 2002
   All Rights Reserved.
   US Government Users Restricted Rights - Use, duplication or
   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
**************************************************************************/
/*************************************************************************
   IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
   ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE. IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL, INDIRECT OR
   CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
   USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
   OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
   OR PERFORMANCE OF THIS SOFTWARE.
**************************************************************************/

package com.ibm.webservices.samples.complex1;

import java.rmi.RemoteException;
import javax.rmi.*;
import java.util.*;
import java.io.*;
import javax.naming.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.net.URLDecoder;

public class Complex1WsClientServlet extends HttpServlet {

	public void init(ServletConfig cfg) throws ServletException {
		super.init(cfg);
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException {

		int errors = 0;
		PrintWriter w = response.getWriter();

		try {

			InitialContext ctx = new InitialContext();

			javax.xml.rpc.Service svc =
				(javax.xml.rpc.Service) ctx.lookup(
					"java:comp/env/service/Complex1WsService1");

			Complex1Ws endPoint = (Complex1Ws) svc.getPort(Complex1Ws.class);

			try {
				boolean inBoolean = true;
				boolean outBoolean = endPoint.testBoolean(inBoolean);
				if (inBoolean == outBoolean) {
					w.println("<BR>testBoolean: FAILED comparison");
					errors++;
				} else
					w.println("<BR>testBoolean: success");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testBoolean: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}

			try {
				byte inByte = '\n';
				byte outByte = endPoint.testByte(inByte);
				if (inByte + 1 != outByte) {
					w.println("<BR>testByte: FAILED comparison");
					errors++;
				} else
					w.println("<BR>testByte: success");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testByte: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}

			try {
				int inInt = 11;
				int outInt = endPoint.testInt(inInt);
				if (inInt + 1 != outInt) {
					w.println("<BR>testInt: FAILED comparison");
					errors++;
				} else
					w.println("<BR>testInt: success");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testInt: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}

			try {
				short inShort = 21;
				short outShort = endPoint.testShort(inShort);
				if (inShort + 1 != outShort) {
					w.println("<BR>testShort: FAILED comparison");
					errors++;
				} else
					w.println("<BR>testShort: success");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testShort: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}

			try {
				long inLong = 31;
				long outLong = endPoint.testLong(inLong);
				if (inLong + 1 != outLong) {
					w.println("<BR>testLong: FAILED comparison");
					errors++;
				} else
					w.println("<BR>testLong: success");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testLong: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}

			try {
				float inFloat = (float) 3.14;
				float outFloat = endPoint.testFloat(inFloat);
				if ((float) (inFloat + 1.0) != outFloat) {
					w.println("<BR>testFloat: FAILED:" + outFloat);
					errors++;
				} else
					w.println("<BR>testFloat: success comparison");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testFloat: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}

			try {
				double inDouble = 4.14;
				double outDouble = endPoint.testDouble(inDouble);
				if (inDouble + 1.0 != outDouble) {
					w.println("<BR>testDouble: FAILED comparison");
					errors++;
				} else
					w.println("<BR>testDouble: success");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testDouble: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}
			String input = "hello there";
			String output = endPoint.testString(input);
			w.println("<BR>input: " + input);
			w.println("<BR>output: " + output);

			try {
				ComplexSer1 inSer1 = new ComplexSer1();
				inSer1.setX(101);
				inSer1.setY(201);
				ComplexSer1 outSer1 = endPoint.testSerializable1(inSer1);
				if ((inSer1.getX() + 1 != outSer1.getX())
					|| (inSer1.getY() + 1 != outSer1.getY())) {
					w.println("<BR>testSerializable1: FAILED comparison");
					errors++;
				} else
					w.println("<BR>testSerializable1: success");
			} catch (Exception ex) {
				errors++;
				w.println("<BR>testSerializable1: FAILED<pre>");
				ex.printStackTrace(w);
				w.println("</pre>");
			}

		} catch (Exception ex) {
			errors++;
			w.println("<pre>");
			ex.printStackTrace(w);
			w.println("</pre>");
		}
		w.println("<BR>" + errors + " errors");

	}
}
