package org.objectweb.jonas.ws;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas.ws.WSDLManager;
// JUnitDoclet end import
import org.objectweb.jonas.ws.handler.FileWSDLHandler;

import java.io.InputStream;
import java.io.FileInputStream;
import java.io.File;
import org.objectweb.jonas_ws.deployment.api.WSDLFile;

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class WSDLManagerTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  org.objectweb.jonas.ws.WSDLManager wsdlmanager = null;
    private String wsdlFileName = "Hello.wsdl";
  // JUnitDoclet end class
  
  public WSDLManagerTest(String name) {
    // JUnitDoclet begin method WSDLManagerTest
    super(name);
    // JUnitDoclet end method WSDLManagerTest
  }
  
  public org.objectweb.jonas.ws.WSDLManager createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance
    return new org.objectweb.jonas.ws.WSDLManager();
    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    wsdlmanager = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    wsdlmanager = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testAddHandler() throws Exception {
    // JUnitDoclet begin method addHandler
    // JUnitDoclet end method addHandler
  }
    
    public void testPublish() throws Exception {
	// JUnitDoclet begin method publish
	
	// add 2 handlers in the manager	
	String genDir = System.getProperty("base.dir") + "output/";
	FileWSDLHandler h1 = new FileWSDLHandler(genDir+"wsdl/");	
	FileWSDLHandler h2 = new FileWSDLHandler(genDir+"wsdl2/");
	wsdlmanager.addHandler(h1);	
	wsdlmanager.addHandler(h2);
	
	// publishing
	File wsdl = new File(System.getProperty("base.dir") + "etc/wsdl/", wsdlFileName);
	InputStream isWsdl = new FileInputStream(wsdl);
	// build the WSDLFile
	WSDLFile wsdlf = new WSDLFile(isWsdl, wsdlFileName);
	wsdlmanager.publish(wsdlf);
	
	// verify that the a wsdl file is correctly published.

	// first publishing
	File wsdl1 = new File(System.getProperty("base.dir") + "output/wsdl/", wsdlFileName);
	InputStream isWsdl1 = new FileInputStream(wsdl1);
	WSDLFile wsdlf1 = new WSDLFile(isWsdl1, wsdlFileName);

	// second publishing
	File wsdl2 = new File(System.getProperty("base.dir") +"output/wsdl2/", wsdlFileName);
	InputStream isWsdl2 = new FileInputStream(wsdl2);
	WSDLFile wsdlf2 = new WSDLFile(isWsdl2, wsdlFileName);	

	assertTrue("The WSDL file '" + wsdlFileName 
		   + "' have not be published in the directory 'output/wsdl/'"
		   ,wsdlf1.equals(wsdlf));
	assertTrue("The WSDL file '" + wsdlFileName 
		   + "' have not be published in the directory 'output/wsdl2/'"
		   ,wsdlf2.equals(wsdlf));
	
	isWsdl1.close();
	isWsdl2.close();
	isWsdl.close();
	
	wsdl1.delete();
	wsdl2.delete();
	
	(new File(System.getProperty("base.dir") +"output/wsdl2/")).delete();
	(new File(System.getProperty("base.dir") +"output/wsdl/")).delete();
	
	// JUnitDoclet end method publish
    }
    
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(WSDLManagerTest.class);
    // JUnitDoclet end method testcase.main
  }
}
