package org.objectweb.jonas.ws.handler;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas.ws.handler.FileWSDLHandler;
// JUnitDoclet end import
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.File;
import org.objectweb.jonas_ws.deployment.api.WSDLFile;
import org.objectweb.jonas.ws.WSServiceException;

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class FileWSDLHandlerTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  org.objectweb.jonas.ws.handler.FileWSDLHandler filewsdlhandler = null;
    private String genDirPath;
    private String wsdlFileName = "Hello.wsdl";	
  
  // JUnitDoclet end class

  public FileWSDLHandlerTest(String name) {
    // JUnitDoclet begin method FileWSDLHandlerTest
    super(name);
    // JUnitDoclet end method FileWSDLHandlerTest
  }
  
  public org.objectweb.jonas.ws.handler.FileWSDLHandler createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance
      System.out.println("genDirPath : "+genDirPath);
      return new org.objectweb.jonas.ws.handler.FileWSDLHandler(genDirPath);
    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    genDirPath = System.getProperty("base.dir") + "output/wsdl/";
    filewsdlhandler = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    filewsdlhandler = null;
    (new File(genDirPath, wsdlFileName)).delete();
    (new File(genDirPath)).delete();
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }

  public void testPublish() throws Exception {
    // JUnitDoclet begin method publish

      // get the WSDLFile to publish.
      //String wsdlFileName = "Hello.wsdl";
      File wsdl = new File(System.getProperty("base.dir") + "etc/wsdl/", 
			   wsdlFileName);
      InputStream isWsdl = new FileInputStream(wsdl);
      // build the WSDLFile
      WSDLFile wsdlf = new WSDLFile(isWsdl, wsdlFileName);
      //test the method
      filewsdlhandler.publish(wsdlf);
      
      // now, verify that the wsdl have been published at wsdldir
      File wsdlRes = new File(genDirPath,wsdlFileName);
      
      // JUnitDoclet end method publish
      InputStream isWsdlRes = new FileInputStream(wsdlRes);
      WSDLFile wsdlfRes = new WSDLFile(isWsdlRes, wsdlFileName);

      assertTrue("The WSDL file '" + wsdlFileName 
		 + "' have not be published in the directory '" + genDirPath
		 + "' ",wsdlfRes.equals(wsdlf));

      isWsdlRes.close();
      isWsdl.close();
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(FileWSDLHandlerTest.class);
    // JUnitDoclet end method testcase.main
  }
}
