package org.objectweb.jonas_ejb.deployment.lib;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ejb.deployment.lib.EjbDeploymentDescManager;
import org.objectweb.jonas_ejb.deployment.api.DeploymentDesc;
import org.objectweb.jonas_ejb.deployment.api.BeanDesc;
import org.objectweb.jonas_ejb.deployment.api.EntityCmp1Desc;
import org.objectweb.jonas_ejb.deployment.api.SessionStatelessDesc;
import org.objectweb.jonas_ejb.deployment.api.SessionStatefulDesc;
import org.objectweb.jonas_ejb.deployment.api.MessageDrivenDesc;
import org.objectweb.jonas_ws.deployment.api.ServiceRef;
import java.net.URL;
import java.net.URLClassLoader;
import java.io.File;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class EjbDeploymentDescManagerTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  EjbDeploymentDescManager ejbDDManager = null;
  // JUnitDoclet end class
  
  public EjbDeploymentDescManagerTest(String name) {
    // JUnitDoclet begin method EjbDeploymentDescManagerTest
    super(name);
    // JUnitDoclet end method EjbDeploymentDescManagerTest
  }
  
  public org.objectweb.jonas_ejb.deployment.lib.EjbDeploymentDescManager createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance
    return EjbDeploymentDescManager.getInstance();
    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    ejbDDManager = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    ejbDDManager = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testGetInstance() throws Exception {
    // JUnitDoclet begin method getInstance
    // JUnitDoclet end method getInstance
  }
  
  public void testGetDeploymentDesc() throws Exception {
    // JUnitDoclet begin method getDeploymentDesc

      String path = System.getProperty("base.dir");
	    
      File f = new File(path + "output/ejbjars/fakeclient.jar");
      URL jar = null;
      try {
	  jar = f.toURL();
      }
      catch(java.net.MalformedURLException neveruse){}

      ClassLoader loader = new URLClassLoader(new URL[] {jar}, Thread.currentThread().getContextClassLoader());

      DeploymentDesc ejbDD = ejbDDManager.getDeploymentDesc(jar, 
							    loader,
							    null);

      // Check loaded Beans

      BeanDesc client1 = ejbDD.getBeanDesc("WsClient1ECL");
      assertNotNull("WsClient1 loaded", client1);
      assertTrue("WsClient1 Type", client1 instanceof EntityCmp1Desc);

      BeanDesc client2 = ejbDD.getBeanDesc("WsClient2SLL");
      assertNotNull("WsClient2 loaded", client2);
      assertTrue("WsClient2 Type", client2 instanceof SessionStatelessDesc);

      BeanDesc client3 = ejbDD.getBeanDesc("WsClient3SFL");
      assertNotNull("WsClient3 loaded", client3);
      assertTrue("WsClient3 Type", client3 instanceof SessionStatefulDesc);
      
      BeanDesc client4 = ejbDD.getBeanDesc("WsClient4MD");
      assertNotNull("WsClient4 loaded", client4);
      assertTrue("WsClient4 Type", client4 instanceof MessageDrivenDesc);
      
      // Check if service-ref have been correctly loaded
      assertEquals("WsClient1 ServiceRef(s)", 1, client1.getServiceRefDesc().length);
      ServiceRef sr1 = client1.getServiceRefDesc()[0];
      assertEquals("service-ref-name", "service/Complex1WsService1", sr1.getServiceRefName());
      assertEquals("jndi-name", "webservice_1", sr1.getJndiName());

      assertEquals("WsClient2 ServiceRef(s)", 1, client2.getServiceRefDesc().length);
      ServiceRef sr2 = client2.getServiceRefDesc()[0];
      assertEquals("service-ref-name", "service/Complex1WsService1", sr2.getServiceRefName());
      assertEquals("jndi-name", "webservice_1", sr2.getJndiName());

      assertEquals("WsClient3 ServiceRef(s)", 1, client3.getServiceRefDesc().length);
      ServiceRef sr3 = client3.getServiceRefDesc()[0];
      assertEquals("service-ref-name", "service/Complex1WsService1", sr3.getServiceRefName());
      assertEquals("jndi-name", "webservice_1", sr3.getJndiName());

      assertEquals("WsClient4 ServiceRef(s)", 1, client4.getServiceRefDesc().length);
      ServiceRef sr4 = client4.getServiceRefDesc()[0];
      assertEquals("service-ref-name", "service/Complex1WsService1", sr4.getServiceRefName());
      assertEquals("jndi-name", "webservice_1", sr4.getJndiName());


    // JUnitDoclet end method getDeploymentDesc
  }
  
  public void testSetAvailableEjbJarsAndAltDDs() throws Exception {
    // JUnitDoclet begin method setAvailableEjbJarsAndAltDDs
    // JUnitDoclet end method setAvailableEjbJarsAndAltDDs
  }
  
  public void testRemoveCache() throws Exception {
    // JUnitDoclet begin method removeCache
    // JUnitDoclet end method removeCache
  }
  
  public void testGetCacheSize() throws Exception {
    // JUnitDoclet begin method getCacheSize
    // JUnitDoclet end method getCacheSize
  }
  
  public void testToString() throws Exception {
    // JUnitDoclet begin method toString
    // JUnitDoclet end method toString
  }
  
  public void testSetGetParsingWithValidation() throws Exception {
    // JUnitDoclet begin method setParsingWithValidation getParsingWithValidation
/*    boolean[] tests = {true, false};
    
    for (int i = 0; i < tests.length; i++) {
      ejbdeploymentdescmanager.setParsingWithValidation(tests[i]);
      assertEquals(tests[i], ejbdeploymentdescmanager.getParsingWithValidation());
    }
*/
    // JUnitDoclet end method setParsingWithValidation getParsingWithValidation
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(EjbDeploymentDescManagerTest.class);
    // JUnitDoclet end method testcase.main
  }
}
