package org.objectweb.jonas_web.deployment.lib;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_web.deployment.lib.WebDeploymentDescManager;
import org.objectweb.jonas_web.deployment.api.WebContainerDeploymentDesc;
import org.objectweb.jonas_ws.deployment.api.ServiceRef;
import java.net.URLClassLoader;
import java.net.URL;
import java.io.File;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class WebDeploymentDescManagerTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  org.objectweb.jonas_web.deployment.lib.WebDeploymentDescManager webDDManager = null;
  // JUnitDoclet end class
  
  public WebDeploymentDescManagerTest(String name) {
    // JUnitDoclet begin method WebDeploymentDescManagerTest
    super(name);
    // JUnitDoclet end method WebDeploymentDescManagerTest
  }
  
  public org.objectweb.jonas_web.deployment.lib.WebDeploymentDescManager createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance
    return WebDeploymentDescManager.getInstance();
    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    webDDManager = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    webDDManager = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testGetInstance() throws Exception {
    // JUnitDoclet begin method getInstance
    // JUnitDoclet end method getInstance
  }
  
  public void testGetDeploymentDesc() throws Exception {
    // JUnitDoclet begin method getDeploymentDesc

      String path = System.getProperty("base.dir");
//      File f = new File(path + "output/webapps/webContainerTest.war");

      File f = new File(path + "output/webapps/fakeclient.war");
      URL war = null;
      try {
	  war = f.toURL();
      }
      catch(java.net.MalformedURLException neveruse){}

      ClassLoader loader = new URLClassLoader(new URL[] {war}, Thread.currentThread().getContextClassLoader());

      WebContainerDeploymentDesc webDD = webDDManager.getDeploymentDesc(war, 
									loader,
									null);

      // Check if service-ref have been correctly loaded
      assertEquals("webDD ServiceRef(s)", 1, webDD.getServiceRefTags().length);

      ServiceRef sr = webDD.getServiceRefTags()[0];

      assertEquals("service-ref-name", "service/Complex1WsService1", sr.getServiceRefName());
      assertEquals("jndi-name", "webservice_1", sr.getJndiName());

    // JUnitDoclet end method getDeploymentDesc
  }
  
  public void testRemoveCache() throws Exception {
    // JUnitDoclet begin method removeCache
    // JUnitDoclet end method removeCache
  }
  
  public void testSetAltDD() throws Exception {
    // JUnitDoclet begin method setAltDD
    // JUnitDoclet end method setAltDD
  }
  
  public void testGetCacheSize() throws Exception {
    // JUnitDoclet begin method getCacheSize
    // JUnitDoclet end method getCacheSize
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(WebDeploymentDescManagerTest.class);
    // JUnitDoclet end method testcase.main
  }
}
