package org.objectweb.jonas_ws.deployment.api;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.api.HandlerDesc;
import org.objectweb.jonas_ws.deployment.xml.Handler;
import org.objectweb.jonas_ws.deployment.xml.HandlerImpl;
import java.util.List;
import java.util.Vector;
import java.util.Hashtable;
import javax.xml.namespace.QName;
import java.io.File;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class HandlerDescTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  HandlerDesc handlerdesc = null;
  // JUnitDoclet end class
  
  public HandlerDescTest(String name) {
    // JUnitDoclet begin method HandlerDescTest
    super(name);
    // JUnitDoclet end method HandlerDescTest
  }
  
  public org.objectweb.jonas_ws.deployment.api.HandlerDesc createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance

      String path = System.getProperty("base.dir");
      Handler h = HandlerImpl.unmarshal(new File(path + "etc/xml/handlerDesc.xml"));
      return new HandlerDesc(Thread.currentThread().getContextClassLoader(), h);

    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    handlerdesc = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    handlerdesc = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testGetSOAPHeaders() throws Exception {
    // JUnitDoclet begin method getSOAPHeaders

      Vector expected = new Vector();
      expected.add(new QName("http://someServer", "anyName"));
      List headers = handlerdesc.getSOAPHeaders();

      assertEquals("SOAP Headers returned OK", expected, headers);

    // JUnitDoclet end method getSOAPHeaders
  }
  
  public void testGetName() throws Exception {
    // JUnitDoclet begin method getName

      assertEquals("handler-name", "MyHandler", handlerdesc.getName());

    // JUnitDoclet end method getName
  }
  
  public void testGetHandlerClass() throws Exception {
    // JUnitDoclet begin method getHandlerClass

      assertEquals("handler-class", sample.MyHandler.class , handlerdesc.getHandlerClass());

    // JUnitDoclet end method getHandlerClass
  }
  
  public void testGetInitParams() throws Exception {
    // JUnitDoclet begin method getInitParams

      Hashtable table = new Hashtable();
      table.put("param1", "value1");
      assertEquals("init-param(s)", table, handlerdesc.getInitParams());

    // JUnitDoclet end method getInitParams
  }
  
  public void testGetInitParam() throws Exception {
    // JUnitDoclet begin method getInitParam

      assertEquals("1 init-param", "value1", handlerdesc.getInitParam("param1"));

    // JUnitDoclet end method getInitParam
  }
  
  public void testGetSOAPRoles() throws Exception {
    // JUnitDoclet begin method getSOAPRoles

      assertEquals("1 init-param", "value1", handlerdesc.getInitParam("param1"));

    // JUnitDoclet end method getSOAPRoles
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(HandlerDescTest.class);
    // JUnitDoclet end method testcase.main
  }
}
