package org.objectweb.jonas_ws.deployment.api;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.api.HandlerRef;
import org.objectweb.jonas_ejb.deployment.xml.HandlerImpl;
import java.io.File;
import javax.xml.namespace.QName;
import java.util.Vector;
import java.util.Hashtable;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class HandlerRefTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  org.objectweb.jonas_ws.deployment.api.HandlerRef handlerref = null;
  // JUnitDoclet end class
  
  public HandlerRefTest(String name) {
    // JUnitDoclet begin method HandlerRefTest
    super(name);
    // JUnitDoclet end method HandlerRefTest
  }
  
  public org.objectweb.jonas_ws.deployment.api.HandlerRef createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance

      String path = System.getProperty("base.dir");
      File f = new File(path + "etc/xml/handlerRef.xml");
      org.objectweb.jonas_ejb.deployment.xml.Handler hr = HandlerImpl.unmarshal(f);
    return new HandlerRef(ClassLoader.getSystemClassLoader(), hr);

    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    handlerref = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    handlerref = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testGetName() throws Exception {
    // JUnitDoclet begin method getName

      assertEquals("handler-name", "MyHandler", handlerref.getName());
      
    // JUnitDoclet end method getName
  }
  
  public void testGetHandlerClass() throws Exception {
    // JUnitDoclet begin method getHandlerClass

      assertEquals("handler-class",
		   Class.forName("sample.MyHandler"),
		   handlerref.getHandlerClass());

    // JUnitDoclet end method getHandlerClass
  }
  
  public void testGetInitParams() throws Exception {
    // JUnitDoclet begin method getInitParams

      Hashtable table = new Hashtable();
      table.put("param1", "value1");
      assertEquals("init-param(s)", table, handlerref.getInitParams());

    // JUnitDoclet end method getInitParams
  }
  
  public void testGetInitParam() throws Exception {
    // JUnitDoclet begin method getInitParam

      assertEquals("1 init-param", "value1", handlerref.getInitParam("param1"));

    // JUnitDoclet end method getInitParam
  }
  
  public void testGetSOAPHeaders() throws Exception {
    // JUnitDoclet begin method getSOAPHeaders

      Vector list = new Vector();
      list.add(new QName("http://complex1.samples.webservices.ibm.com", "in0"));
      assertEquals("soap-headers", list, handlerref.getSOAPHeaders());

    // JUnitDoclet end method getSOAPHeaders
  }
  
  public void testGetSOAPRoles() throws Exception {
    // JUnitDoclet begin method getSOAPRoles

      Vector list = new Vector();
      list.add("SOAP-Role");
      assertEquals("soap-role(s)", list, handlerref.getSOAPRoles());

    // JUnitDoclet end method getSOAPRoles
  }
  
  public void testGetPortNames() throws Exception {
    // JUnitDoclet begin method getPortNames

      Vector list = new Vector();
      list.add("Complex1");
      assertEquals("port-name(s)", list, handlerref.getPortNames());

    // JUnitDoclet end method getPortNames
  }
  
  public void testEquals() throws Exception {
    // JUnitDoclet begin method equals
    // JUnitDoclet end method equals
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(HandlerRefTest.class);
    // JUnitDoclet end method testcase.main
  }
}
