package org.objectweb.jonas_ws.deployment.api;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.api.PortComponentDesc;
import org.objectweb.jonas_ws.deployment.api.HandlerDesc;
import org.objectweb.jonas_ws.deployment.xml.PortComponent;
import org.objectweb.jonas_ws.deployment.xml.PortComponentImpl;
import java.util.List;
import java.util.Vector;
import java.io.File;
import javax.xml.namespace.QName;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class PortComponentDescTest
// JUnitDoclet begin extends_implements
    extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
    PortComponentDesc pcd = null;
  // JUnitDoclet end class
  
  public PortComponentDescTest(String name) {
    // JUnitDoclet begin method PortComponentDescTest
	super(name);
    // JUnitDoclet end method PortComponentDescTest
  }
  
  public org.objectweb.jonas_ws.deployment.api.PortComponentDesc createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance

	String path = System.getProperty("base.dir");
	File f = new File(path + "etc/xml/portComponentDesc.xml");
	PortComponent pc = PortComponentImpl.unmarshal(f);

	return new PortComponentDesc(Thread.currentThread().getContextClassLoader(), pc);

    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
	super.setUp();
	pcd = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
	pcd = null;
	super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testGetName() throws Exception {
    // JUnitDoclet begin method getName

	assertEquals("port-component-name", "MyPortComponent", pcd.getName());
      
    // JUnitDoclet end method getName
  }
  
  public void testGetServiceEndpointInterface() throws Exception {
    // JUnitDoclet begin method getServiceEndpointInterface

	assertEquals("service-endpoint-interface",
		     sample.ServiceEndpointInterface.class,
		     pcd.getServiceEndpointInterface());

    // JUnitDoclet end method getServiceEndpointInterface
  }
  
  public void testGetServiceImplementationBean() throws Exception {
    // JUnitDoclet begin method getServiceImplementationBean

	pcd.setSibClass(sample.PortComponent.class);

	assertEquals("service-impl-bean", 
		     sample.PortComponent.class,
		     pcd.getServiceImplementationBean());

    // JUnitDoclet end method getServiceImplementationBean
  }
  
  public void testGetQName() throws Exception {
    // JUnitDoclet begin method getQName

	QName pName = new QName("http://namespace", "localpart");
	assertEquals("wsdl-port", pName, pcd.getQName());

    // JUnitDoclet end method getQName
  }
  
  public void testGetHandlers() throws Exception {
    // JUnitDoclet begin method getHandlers

	List handlers = pcd.getHandlers();

	assertEquals("handler size", 1, handlers.size());

	HandlerDesc h = (HandlerDesc) handlers.get(0);

	assertEquals("handler/handler-name", 
		     "MyHandler", 
		     h.getName());
	assertEquals("handler/handler-class", 
		     sample.MyHandler.class, 
		     h.getHandlerClass());

    // JUnitDoclet end method getHandlers
  }
  
  public void testGetSibLink() throws Exception {
    // JUnitDoclet begin method getSibLink

	assertEquals("service-impl-bean", "portComp", pcd.getSibLink());

    // JUnitDoclet end method getSibLink
  }
  
  public void testSetSibClass() throws Exception {
    // JUnitDoclet begin method setSibClass

	// see testGetServiceImplementationBean
      
    // JUnitDoclet end method setSibClass
  }
  
  public void testHasBeanImpl() throws Exception {
    // JUnitDoclet begin method hasBeanImpl

	assertFalse("hasBeanImpl", pcd.hasBeanImpl());

    // JUnitDoclet end method hasBeanImpl
  }
  
  public void testHasJaxRpcImpl() throws Exception {
    // JUnitDoclet begin method hasJaxRpcImpl

	assertTrue("hasJaxRpcImpl", pcd.hasJaxRpcImpl());
      
    // JUnitDoclet end method hasJaxRpcImpl
  }
  
  public void testSetGetBeanDesc() throws Exception {
    // JUnitDoclet begin method setBeanDesc getBeanDesc

	/*
	// Too complicated to test
	// assume to be OK
	org.objectweb.jonas_ejb.deployment.api.SessionStatelessDesc[] tests = {new org.objectweb.jonas_ejb.deployment.api.SessionStatelessDesc(), null};
    
	for (int i = 0; i < tests.length; i++) {
	pcd.setBeanDesc(tests[i]);
	assertEquals(tests[i], pcd.getBeanDesc());
	}
	*/
    // JUnitDoclet end method setBeanDesc getBeanDesc
  }
  
  public void testSetGetWebDesc() throws Exception {
    // JUnitDoclet begin method setWebDesc getWebDesc
	/*
	// Too complicated to test
	// assume to be OK
	org.objectweb.jonas_web.deployment.api.WebContainerDeploymentDesc[] tests = {new org.objectweb.jonas_web.deployment.api.WebContainerDeploymentDesc(), null};
	
	for (int i = 0; i < tests.length; i++) {
	portcomponentdesc.setWebDesc(tests[i]);
	assertEquals(tests[i], portcomponentdesc.getWebDesc());
	}
	*/
    // JUnitDoclet end method setWebDesc getWebDesc
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
	junit.textui.TestRunner.run(PortComponentDescTest.class);
    // JUnitDoclet end method testcase.main
  }
}
