package org.objectweb.jonas_ws.deployment.api;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.api.ServiceDesc;
import org.objectweb.jonas_ws.deployment.xml.WebserviceDescription;
import org.objectweb.jonas_ws.deployment.xml.WebserviceDescriptionImpl;
import java.io.File;
import javax.xml.namespace.QName;
import java.util.List;
import java.io.InputStream;
import java.util.jar.JarFile;
import org.objectweb.jonas_ws.deployment.api.WSDLFile;
import org.objectweb.jonas_ws.deployment.api.MappingFile;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class ServiceDescTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  org.objectweb.jonas_ws.deployment.api.ServiceDesc sd = null;
  // JUnitDoclet end class
  
  public ServiceDescTest(String name) {
    // JUnitDoclet begin method ServiceDescTest
    super(name);
    // JUnitDoclet end method ServiceDescTest
  }
  
  public org.objectweb.jonas_ws.deployment.api.ServiceDesc createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance

      String path = System.getProperty("base.dir");
      File f = new File(path + "etc/xml/serviceDesc.xml");
      WebserviceDescription wsd = WebserviceDescriptionImpl.unmarshal(f);

      return new ServiceDesc(Thread.currentThread().getContextClassLoader(),
			     wsd,
			     path + "output/ejbjars/fakeendpoint.jar");

    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    sd = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    sd = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testGetName() throws Exception {
    // JUnitDoclet begin method getName

      assertEquals("webservice-description-name",
		   "MyWebService",
		   sd.getName());

    // JUnitDoclet end method getName
  }
  
  public void testGetMapping() throws Exception {
    // JUnitDoclet begin method getMapping

      String path = System.getProperty("base.dir");

      JarFile module = new JarFile(path + "output/ejbjars/fakeendpoint.jar");
      InputStream isMapping = module.getInputStream(module.getEntry("META-INF/Complex1Mapping.xml"));

      MappingFile mapping = new MappingFile(isMapping, "META-INF/Complex1Mapping.xml");

      assertEquals("jaxrpc-mapping-file", mapping, sd.getMapping());
      

    // JUnitDoclet end method getMapping
  }
  
  public void testGetWSDL() throws Exception {
    // JUnitDoclet begin method getWSDL

      String path = System.getProperty("base.dir");

      JarFile module = new JarFile(path + "output/ejbjars/fakeendpoint.jar");
      InputStream isWsdl = module.getInputStream(module.getEntry("META-INF/Complex1.wsdl"));

      WSDLFile wsdl = new WSDLFile(isWsdl, "META-INF/Complex1.wsdl");

      assertEquals("wsdl-file", wsdl, sd.getWSDL());

    // JUnitDoclet end method getWSDL
  }
  
  public void testGetPortComponents() throws Exception {
    // JUnitDoclet begin method getPortComponents
      List list = sd.getPortComponents();

      assertEquals("port-component list", 1, list.size());

      PortComponentDesc pcd = (PortComponentDesc) list.get(0);

      assertEquals("port-component/port-component-name", 
		   "MyPortComponent",
		   pcd.getName());

      assertEquals("port-component/wsdl-port",
		   new QName("http://complex1.samples.webservices.ibm.com", "Complex1"),
		   pcd.getQName());

      assertEquals("port-component/sei",
		   sample.ServiceEndpointInterface.class,
		   pcd.getServiceEndpointInterface());

      assertNull("port-component/sib", 
		 pcd.getServiceImplementationBean());

    // JUnitDoclet end method getPortComponents
  }
  
  public void testGetPortComponent() throws Exception {
    // JUnitDoclet begin method getPortComponent

      PortComponentDesc pcd = sd.getPortComponent("MyPortComponent");
      assertNotNull("getPortComponent", pcd);

      assertEquals("pcd/name", "MyPortComponent", pcd.getName());

    // JUnitDoclet end method getPortComponent
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(ServiceDescTest.class);
    // JUnitDoclet end method testcase.main
  }
}
