package org.objectweb.jonas_ws.deployment.api;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.api.ServiceRef;
import org.objectweb.jonas_ejb.deployment.xml.ServiceRefImpl;
import org.objectweb.jonas_ejb.deployment.xml.HandlerImpl;
import org.objectweb.jonas_ejb.deployment.xml.JonasServiceRefImpl;
import java.io.File;
import java.io.FileInputStream;
import java.util.Vector;
import java.util.List;
import java.util.Hashtable;
import javax.xml.namespace.QName;
// JUnitDoclet end import

/**
 * Generated by JUnitDoclet, a tool provided by
 * ObjectFab GmbH under LGPL.
 * Please see www.junitdoclet.org, www.gnu.org
 * and www.objectfab.de for informations about
 * the tool, the licence and the authors.
 */


public class ServiceRefTest
    // JUnitDoclet begin extends_implements
    extends TestCase
    // JUnitDoclet end extends_implements
{
    // JUnitDoclet begin class
    org.objectweb.jonas_ws.deployment.api.ServiceRef serviceref = null;
    // JUnitDoclet end class
  
    public ServiceRefTest(String name) {
	// JUnitDoclet begin method ServiceRefTest
	super(name);
	// JUnitDoclet end method ServiceRefTest
    }
  
    public org.objectweb.jonas_ws.deployment.api.ServiceRef createInstance() throws Exception {
	// JUnitDoclet begin method testcase.createInstance

	String path = System.getProperty("base.dir");

	File sr = new File(path + "etc/xml/serviceRefTest.xml");
	org.objectweb.jonas_ejb.deployment.xml.ServiceRef sri = ServiceRefImpl.unmarshal(sr);
	File jsr = new File(path + "etc/xml/jonasServiceRef.xml");
	org.objectweb.jonas_ejb.deployment.xml.JonasServiceRef jsri = JonasServiceRefImpl.unmarshal(jsr);

	return new ServiceRef(Thread.currentThread().getContextClassLoader(),
			      sri,
			      jsri,
			      path);

	// JUnitDoclet end method testcase.createInstance
    }
  
    protected void setUp() throws Exception {
	// JUnitDoclet begin method testcase.setUp
	super.setUp();
	serviceref = createInstance();
	// JUnitDoclet end method testcase.setUp
    }
  
    protected void tearDown() throws Exception {
	// JUnitDoclet begin method testcase.tearDown
	serviceref = null;
	super.tearDown();
	// JUnitDoclet end method testcase.tearDown
    }
  
    public void testGetPortComponentRefs() throws Exception {
	// JUnitDoclet begin method getPortComponentRefs

	List l = serviceref.getPortComponentRefs();
	assertEquals("right number of PortComponentRefs", 1, l.size());

	PortComponentRef pcr = (PortComponentRef) l.get(0);
	assertEquals("port-component-ref.sei",
		     Class.forName("com.ibm.webservices.samples.complex1.Complex1Ws"),
		     pcr.getSEI());
	assertNull("port-component-ref.pclink",
		   pcr.getPortComponentLink());

	// JUnitDoclet end method getPortComponentRefs
    }
  
    public void testGetHandlerRefs() throws Exception {
	// JUnitDoclet begin method getHandlerRefs
      
	String path = System.getProperty("base.dir");
	File f = new File(path + "etc/xml/handlerRef.xml");
	org.objectweb.jonas_ejb.deployment.xml.Handler in = HandlerImpl.unmarshal(f);
	HandlerRef exp = new HandlerRef(ClassLoader.getSystemClassLoader(), in);

	List l = serviceref.getHandlerRefs();
	assertEquals("right number of HandlerRefs", 1, l.size());

	HandlerRef hr = (HandlerRef) l.get(0);

	assertEquals("handler", exp, hr);

	// JUnitDoclet end method getHandlerRefs
    }
  
    public void testGetServiceRefName() throws Exception {
	// JUnitDoclet begin method getServiceRefName

	assertEquals("service-ref-name",
		     "service/Complex1WsService1",
		     serviceref.getServiceRefName());

	// JUnitDoclet end method getServiceRefName
    }
  
    public void testGetServiceInterface() throws Exception {
	// JUnitDoclet begin method getServiceInterface

	assertEquals("service-interface",
		     Class.forName("javax.xml.rpc.Service"),
		     serviceref.getServiceInterface());

	// JUnitDoclet end method getServiceInterface
    }
  
    public void testGetWSDLFile() throws Exception {
	// JUnitDoclet begin method getWSDLFile

	String path = System.getProperty("base.dir");

	File cm = new File(path + "etc/wsdl/Complex1.wsdl");
	WSDLFile wf = new WSDLFile(new FileInputStream(cm), "etc/wsdl/Complex1.wsdl");

	assertEquals("wsdl-file", wf, serviceref.getWSDLFile());

	// JUnitDoclet end method getWSDLFile
    }
  
    public void testGetMappingFile() throws Exception {
	// JUnitDoclet begin method getMappingFile

	String path = System.getProperty("base.dir");

	File cm = new File(path + "etc/mapping/Complex1Mapping.xml");
	MappingFile mf = new MappingFile(new FileInputStream(cm), "etc/mapping/Complex1Mapping.xml");

	assertEquals("jaxrpc-mapping-file", mf, serviceref.getMappingFile());

	// JUnitDoclet end method getMappingFile
    }
  
    public void testGetServiceClass() throws Exception {
	// JUnitDoclet begin method getServiceClass

	assertEquals("service-class",
		     Class.forName("org.apache.axis.client.Service"),
		     serviceref.getServiceClass());

	// JUnitDoclet end method getServiceClass
    }
  
    public void testGetParams() throws Exception {
	// JUnitDoclet begin method getParams

	Hashtable map = new Hashtable();
	map.put("param1", "value1");
	map.put("serviceClassName", "org.apache.axis.client.Service");

	assertEquals("jonas-init-param(s)", map, serviceref.getParams());

	// JUnitDoclet end method getParams
    }
  
    public void testGetParam() throws Exception {
	// JUnitDoclet begin method getParam

	assertEquals("1 jonas-init-param", "value1", serviceref.getParam("param1"));

	// JUnitDoclet end method getParam
    }
  
    public void testGetJndiName() throws Exception {
	// JUnitDoclet begin method getJndiName

	assertEquals("jndi-name", "MyJNDIName", serviceref.getJndiName());

	// JUnitDoclet end method getJndiName
    }
  
    public void testGetWsdlFileName() throws Exception {
	// JUnitDoclet begin method getWsdlFileName

	assertEquals("getWsdlFileName", "etc/wsdl/Complex1.wsdl",  serviceref.getWsdlFileName());

	// JUnitDoclet end method getWsdlFileName
    }
  
    public void testGetServiceQName() throws Exception {
	// JUnitDoclet begin method getServiceQName

	QName sqn = new QName("http://complex1.samples.webservices.ibm.com", 
			      "Complex1WsService");
	assertEquals("getServiceQName", sqn, serviceref.getServiceQName());

	// JUnitDoclet end method getServiceQName
    }
  
    public void testEquals() throws Exception {
	// JUnitDoclet begin method equals
	// JUnitDoclet end method equals
    }
  
  
  
    /**
     * JUnitDoclet moves marker to this method, if there is not match
     * for them in the regenerated code and if the marker is not empty.
     * This way, no test gets lost when regenerating after renaming.
     * Method testVault is supposed to be empty.
     */
    public void testVault() throws Exception {
	// JUnitDoclet begin method testcase.testVault
	// JUnitDoclet end method testcase.testVault
    }
  
    public static void main(String[] args) {
	// JUnitDoclet begin method testcase.main
	junit.textui.TestRunner.run(ServiceRefTest.class);
	// JUnitDoclet end method testcase.main
    }
}
