package org.objectweb.jonas_ws.deployment.api;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.api.WSDLFile;
import java.io.FileInputStream;
import javax.wsdl.Definition;
import java.util.Vector;
import javax.xml.namespace.QName;
import java.net.URL;
// JUnitDoclet end import

/**
 * Generated by JUnitDoclet, a tool provided by
 * ObjectFab GmbH under LGPL.
 * Please see www.junitdoclet.org, www.gnu.org
 * and www.objectfab.de for informations about
 * the tool, the licence and the authors.
 */


public class WSDLFileTest
    // JUnitDoclet begin extends_implements
    extends TestCase
    // JUnitDoclet end extends_implements
{
    // JUnitDoclet begin class
    WSDLFile wsdlfile = null;
    // JUnitDoclet end class
  
    public WSDLFileTest(String name) {
	// JUnitDoclet begin method WSDLFileTest
	super(name);
	// JUnitDoclet end method WSDLFileTest
    }
  
    public org.objectweb.jonas_ws.deployment.api.WSDLFile createInstance() throws Exception {
	// JUnitDoclet begin method testcase.createInstance

	String path = System.getProperty("base.dir");
      
	FileInputStream fis = new FileInputStream(path + "etc/wsdl/complexDefinition.wsdl");
	return new WSDLFile(fis, path + "etc/wsdl/complexDefinition.wsdl");
      
	// JUnitDoclet end method testcase.createInstance
    }
  
    protected void setUp() throws Exception {
	// JUnitDoclet begin method testcase.setUp
	super.setUp();
	wsdlfile = createInstance();
	// JUnitDoclet end method testcase.setUp
    }
  
    protected void tearDown() throws Exception {
	// JUnitDoclet begin method testcase.tearDown
	wsdlfile = null;
	super.tearDown();
	// JUnitDoclet end method testcase.tearDown
    }
  
    public void testHasPort() throws Exception {
	// JUnitDoclet begin method hasPort

	QName port = new QName("http://mapmobile", "mapSoap");
	assertTrue("test WSDL Definition has specified Port",
		   wsdlfile.hasPort(port));

	// JUnitDoclet end method hasPort
    }
  
    public void testHasService() throws Exception {
	// JUnitDoclet begin method hasService

	assertTrue("test WSDL Definition has specified Service",
		   wsdlfile.hasService(new QName("http://mapmobile",
						 "map")));

	// JUnitDoclet end method hasService
    }
  
    public void testHasSOAPHeader() throws Exception {
	// JUnitDoclet begin method hasSOAPHeader

	assertTrue("test WSDL Definition has specified SOAP Header",
		   wsdlfile.hasSOAPHeader(new QName("http://mapmobile",
						    "MapMobileHeader")));

	// JUnitDoclet end method hasSOAPHeader
    }
  
    public void testHasPortsIncludedIn() throws Exception {
	// JUnitDoclet begin method hasPortsIncludedIn

	Vector list = new Vector();
	list.add(new QName("http://mapmobile", "mapSoap"));
	assertTrue("WSDL containes specified ports",
		   wsdlfile.hasPortsIncludedIn(list));

	// JUnitDoclet end method hasPortsIncludedIn
    }
  
    public void testHasSOAPBinding() throws Exception {
	// JUnitDoclet begin method hasSOAPBinding

	QName port = new QName("http://mapmobile", "mapSoap");
	assertTrue("test hasSOAPBinding", wsdlfile.hasSOAPBinding(port));

	// JUnitDoclet end method hasSOAPBinding
    }
  
    public void testGetDefinition() throws Exception {
	// JUnitDoclet begin method getDefinition

	Definition def = wsdlfile.getDefinition();

	QName srvQN = new QName("http://mapmobile", "map");
	assertNotNull("Finding Service", def.getService(srvQN));

	QName ptQN = new QName("http://mapmobile", "mapSoap");
	assertNotNull("Finding PortType", def.getPortType(ptQN));

	QName bndQN = new QName("http://mapmobile", "mapSoap");
	assertNotNull("Finding Binding", def.getBinding(bndQN));

	// JUnitDoclet end method getDefinition
    }
  
    public void testGetNbServices() throws Exception {
	// JUnitDoclet begin method getNbServices

	assertEquals("getNbServices", 1, wsdlfile.getNbServices());

	// JUnitDoclet end method getNbServices
    }
  
    public void testGetServiceQname() throws Exception {
	// JUnitDoclet begin method getServiceQname

	QName sqn = new QName("http://mapmobile", 
			      "map");
	assertEquals("getServiceQName", sqn, wsdlfile.getServiceQname());

	// JUnitDoclet end method getServiceQname
    }
  
    public void testGetLocation() throws Exception {
	// JUnitDoclet begin method getLocation

	URL oldEndpoint = new URL("http://localhost/mapmobile/map.asmx");
	QName port = new QName("http://mapmobile", "mapSoap");

	assertEquals("old endpoint return", oldEndpoint, wsdlfile.getLocation(port));

	// JUnitDoclet end method getLocation
    }
  
    public void testSetLocation() throws Exception {
	// JUnitDoclet begin method setLocation

	URL newEndpoint = new URL("http://localhost:8080/context/services/PortEndpoint");
	QName port = new QName("http://mapmobile", "mapSoap");

	wsdlfile.setLocation(port, newEndpoint);
	assertEquals("new endpoint return", newEndpoint, wsdlfile.getLocation(port));

	// JUnitDoclet end method setLocation
    }
  
    public void testGetName() throws Exception {
	// JUnitDoclet begin method getName

	String path = System.getProperty("base.dir");
	assertEquals("WSDL filename", path + "etc/wsdl/complexDefinition.wsdl", wsdlfile.getName());

	// JUnitDoclet end method getName
    }
  
    public void testEquals() throws Exception {
	// JUnitDoclet begin method equals
	// JUnitDoclet end method equals
    }
  
  
  
    /**
     * JUnitDoclet moves marker to this method, if there is not match
     * for them in the regenerated code and if the marker is not empty.
     * This way, no test gets lost when regenerating after renaming.
     * Method testVault is supposed to be empty.
     */
    public void testVault() throws Exception {
	// JUnitDoclet begin method testcase.testVault
	// JUnitDoclet end method testcase.testVault
    }
  
    public static void main(String[] args) {
	// JUnitDoclet begin method testcase.main
	junit.textui.TestRunner.run(WSDLFileTest.class);
	// JUnitDoclet end method testcase.main
    }
}
