package org.objectweb.jonas_ws.deployment.api;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.api.WSDeploymentDesc;
import org.objectweb.jonas_ws.deployment.xml.Webservices;
import org.objectweb.jonas_ws.deployment.xml.WebservicesImpl;
import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.api.BasicLevel;
import java.util.List;
import java.io.InputStream;
import java.util.jar.JarFile;
import java.io.File;
import org.objectweb.jonas_ws.deployment.api.WSDLFile;
import org.objectweb.jonas_ws.deployment.api.MappingFile;
import org.objectweb.jonas_ws.deployment.api.ServiceDesc;
import org.objectweb.jonas.common.Log;
// JUnitDoclet end import

/**
 * Generated by JUnitDoclet, a tool provided by
 * ObjectFab GmbH under LGPL.
 * Please see www.junitdoclet.org, www.gnu.org
 * and www.objectfab.de for informations about
 * the tool, the licence and the authors.
 */


public class WSDeploymentDescTest
    // JUnitDoclet begin extends_implements
    extends TestCase
    // JUnitDoclet end extends_implements
{
    // JUnitDoclet begin class
    WSDeploymentDesc wsdd = null;
    // JUnitDoclet end class
  
    public WSDeploymentDescTest(String name) {
	// JUnitDoclet begin method WSDeploymentDescTest
	super(name);
	// JUnitDoclet end method WSDeploymentDescTest
    }
  
    public org.objectweb.jonas_ws.deployment.api.WSDeploymentDesc createInstance() throws Exception {
	// JUnitDoclet begin method testcase.createInstance

	String path = System.getProperty("base.dir");
	File f = new File(path + "etc/xml/webServiceDeplDesc.xml");
	Webservices ws = WebservicesImpl.unmarshal(f);

	return new WSDeploymentDesc(Thread.currentThread().getContextClassLoader(),
				    Log.getLogger("org.objectweb.jonas_ws.deployment.api"),
				    ws,
				    path + "output/ejbjars/fakeendpoint.jar");

	// JUnitDoclet end method testcase.createInstance
    }
  
    protected void setUp() throws Exception {
	// JUnitDoclet begin method testcase.setUp
	super.setUp();
	wsdd = createInstance();
	// JUnitDoclet end method testcase.setUp
    }
  
    protected void tearDown() throws Exception {
	// JUnitDoclet begin method testcase.tearDown
	wsdd = null;
	super.tearDown();
	// JUnitDoclet end method testcase.tearDown
    }
  
    public void testGetServiceDescs() throws Exception {
	// JUnitDoclet begin method getServiceDescs

	List list = wsdd.getServiceDescs();
	assertEquals("webservice-description list", 1, list.size());

	ServiceDesc sd = (ServiceDesc) list.get(0);
      
	assertEquals("webservice-description/webservice-description-name",
		     "MyWebService",
		     sd.getName());

	String path = System.getProperty("base.dir");

	JarFile module = new JarFile(path + "output/ejbjars/fakeendpoint.jar");
	InputStream isWsdl = module.getInputStream(module.getEntry("META-INF/Complex1.wsdl"));
	InputStream isMapping = module.getInputStream(module.getEntry("META-INF/Complex1Mapping.xml"));

	WSDLFile wsdl = new WSDLFile(isWsdl, "META-INF/Complex1.wsdl");
	MappingFile mapping = new MappingFile(isMapping, "META-INF/Complex1Mapping.xml");

	assertEquals("webservice-description/wsdl-file", wsdl, sd.getWSDL());
	assertEquals("webservice-description/jaxrpc-mapping-file", mapping, sd.getMapping());

	// JUnitDoclet end method getServiceDescs
    }
  
    public void testGetDisplayName() throws Exception {
	// JUnitDoclet begin method getDisplayName

	assertEquals("display-name", "MySetOfWebServices", wsdd.getDisplayName());

	// JUnitDoclet end method getDisplayName
    }
  
    public void testToString() throws Exception {
	// JUnitDoclet begin method toString
	// JUnitDoclet end method toString
    }
  
  
  
    /**
     * JUnitDoclet moves marker to this method, if there is not match
     * for them in the regenerated code and if the marker is not empty.
     * This way, no test gets lost when regenerating after renaming.
     * Method testVault is supposed to be empty.
     */
    public void testVault() throws Exception {
	// JUnitDoclet begin method testcase.testVault
	// JUnitDoclet end method testcase.testVault
    }
  
    public static void main(String[] args) {
	// JUnitDoclet begin method testcase.main
	junit.textui.TestRunner.run(WSDeploymentDescTest.class);
	// JUnitDoclet end method testcase.main
    }
}
