package org.objectweb.jonas_ws.deployment.lib;

import junit.framework.TestCase;
// JUnitDoclet begin import
import org.objectweb.jonas_ws.deployment.lib.WSDeploymentDescManager;
import java.io.File;
import java.net.URL;
import java.net.MalformedURLException;
import java.net.URLClassLoader;
import org.objectweb.jonas_ws.deployment.api.WSDeploymentDesc;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the authors.
*/


public class WSDeploymentDescManagerTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  WSDeploymentDescManager wsDDManager = null;
  // JUnitDoclet end class
  
  public WSDeploymentDescManagerTest(String name) {
    // JUnitDoclet begin method WSDeploymentDescManagerTest
    super(name);
    // JUnitDoclet end method WSDeploymentDescManagerTest
  }
  
  public org.objectweb.jonas_ws.deployment.lib.WSDeploymentDescManager createInstance() throws Exception {
    // JUnitDoclet begin method testcase.createInstance
    return WSDeploymentDescManager.getInstance();
    // JUnitDoclet end method testcase.createInstance
  }
  
  protected void setUp() throws Exception {
    // JUnitDoclet begin method testcase.setUp
    super.setUp();
    wsDDManager = createInstance();
    // JUnitDoclet end method testcase.setUp
  }
  
  protected void tearDown() throws Exception {
    // JUnitDoclet begin method testcase.tearDown
    wsDDManager = null;
    super.tearDown();
    // JUnitDoclet end method testcase.tearDown
  }
  
  public void testGetInstance() throws Exception {
    // JUnitDoclet begin method getInstance

      WSDeploymentDescManager other = WSDeploymentDescManager.getInstance();
      assertSame("WSDeploymentDescManager.getInstance", other, wsDDManager);

    // JUnitDoclet end method getInstance
  }
  
  public void testGetDeploymentDesc() throws Exception {
    // JUnitDoclet begin method getDeploymentDesc

      // loading test
      String path = System.getProperty("base.dir");
      File f = new File(path + "output/webapps/wsManagerTest.war");
      URL url = null;
      try {
	  url = f.toURL();
      }
      catch (MalformedURLException neverUsed) {}

      WSDeploymentDesc wsDD = loadWebServices(url);
      assertNotNull("WSDeploymentDesc loaded", wsDD);

      // cache test
      WSDeploymentDesc cached = loadWebServices(url);
      assertSame("cache tests", wsDD, cached);

    // JUnitDoclet end method getDeploymentDesc
  }
  
  public void testGetCacheSize() throws Exception {
    // JUnitDoclet begin method getCacheSize

      wsDDManager.clearCache();

      assertEquals("pre cache size", 0, wsDDManager.getCacheSize());

      String path = System.getProperty("base.dir");
      File f = new File(path + "output/webapps/wsManagerTest.war");
      URL url = null;
      try {
	  url = f.toURL();
      }
      catch (MalformedURLException neverUsed) {}

      loadWebServices(url);

      assertEquals("post cache size", 1, wsDDManager.getCacheSize());

    // JUnitDoclet end method getCacheSize
  }
  
  public void testToString() throws Exception {
    // JUnitDoclet begin method toString
    // JUnitDoclet end method toString
  }
  
  public void testSetGetParsingWithValidation() throws Exception {
    // JUnitDoclet begin method setParsingWithValidation getParsingWithValidation
    boolean[] tests = {true, false};
    
    for (int i = 0; i < tests.length; i++) {
      wsDDManager.setParsingWithValidation(tests[i]);
      assertEquals(tests[i], wsDDManager.getParsingWithValidation());
    }
    // JUnitDoclet end method setParsingWithValidation getParsingWithValidation
  }

    private WSDeploymentDesc loadWebServices(URL url)
	throws Exception {

	ClassLoader loader = new URLClassLoader(new URL[] {url},
						Thread.currentThread().getContextClassLoader());
	
	WSDeploymentDesc wsDD = wsDDManager.getDeploymentDesc(url, 
							      loader,
							      null);
	return wsDD;
    }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testcase.testVault
    // JUnitDoclet end method testcase.testVault
  }
  
  public static void main(String[] args) {
    // JUnitDoclet begin method testcase.main
    junit.textui.TestRunner.run(WSDeploymentDescManagerTest.class);
    // JUnitDoclet end method testcase.main
  }
}
